#!/bin/sh

title()
{
	echo -e "\e[32m:: $1 :: \e[0m"
}

title "Path list"
mdbus2 -s com.samsung.sapd

title "Create test session (hello/callhandler/XYZ012/{104|105}"
mdbus2 -s com.samsung.sapd / com.samsung.sapd.Manager.CreateService hello
mdbus2 -s com.samsung.sapd /Service/hello com.samsung.sapd.Service.CreateApplication callhandler
mdbus2 -s com.samsung.sapd /Service/hello/callhandler com.samsung.sapd.Application.CreateRemoteAgent XYZ012
mdbus2 -s com.samsung.sapd /Service/hello/callhandler/XYZ012 com.samsung.sapd.RemoteAgent.CreateChannel 104
mdbus2 -s com.samsung.sapd /Service/hello/callhandler/XYZ012 com.samsung.sapd.RemoteAgent.CreateChannel 105

dbus-send --system --print-reply --dest=com.samsung.sapd /Service/hello org.freedesktop.DBus.Properties.Set string:"com.samsung.sapd.Service" string:"spf_name" variant:string:"callhandler"
dbus-send --system --print-reply --dest=com.samsung.sapd /Service/hello org.freedesktop.DBus.Properties.Set string:"com.samsung.sapd.Service" string:"connection_type" variant:string:"bt,usb"
dbus-send --system --print-reply --dest=com.samsung.sapd /Service/hello org.freedesktop.DBus.Properties.Set string:"com.samsung.sapd.Service" string:"role" variant:string:"consumer"
title "Get Service Properties"
mdbus2 -s com.samsung.sapd /Service/hello org.freedesktop.DBus.Properties.GetAll "com.samsung.sapd.Service"

title "channel - 104"
dbus-send --system --print-reply --dest=com.samsung.sapd /Service/hello/callhandler/XYZ012/104 org.freedesktop.DBus.Properties.Set string:"com.samsung.sapd.Channel" string:"payload_type" variant:string:"json"
mdbus2 -s com.samsung.sapd /Service/hello/callhandler/XYZ012/104 org.freedesktop.DBus.Properties.GetAll "com.samsung.sapd.Channel"
mdbus2 -s com.samsung.sapd /Service/hello/callhandler/XYZ012/104 com.samsung.sapd.Channel.Send "{id:'haha'}"

title "channel - 105"
dbus-send --system --print-reply --dest=com.samsung.sapd /Service/hello/callhandler/XYZ012/105 org.freedesktop.DBus.Properties.Set string:"com.samsung.sapd.Channel" string:"payload_type" variant:string:"binary"
mdbus2 -s com.samsung.sapd /Service/hello/callhandler/XYZ012/105 org.freedesktop.DBus.Properties.GetAll "com.samsung.sapd.Channel"
mdbus2 -s com.samsung.sapd /Service/hello/callhandler/XYZ012/104 com.samsung.sapd.Channel.Send "1234567890"

title "Get session's service list"
mdbus2 -s com.samsung.sapd /Service/hello com.samsung.sapd.Service.GetApplications

title "Add weather service"
mdbus2 -s com.samsung.sapd /Service/hello com.samsung.sapd.Service.CreateApplication weatherhandler

title "Path list"
mdbus2 -s com.samsung.sapd
